/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can_Prc.h 842 2014-12-04 11:18:34Z shigihara $
 */

#ifndef TOPPERS_CAN_PRC_H
#define TOPPERS_CAN_PRC_H

#include "Can.h"
#include "Can_InlineSymbols.h"
#include "prc_sil.h"


/*
 *  
 */

/* åХåեϢ */
#define DEF_MESSAGE_BUFFER_MAX		(64U)
#define TX_MB_START_IDX(ctrl_id)	(GET_HRH_NUM(ctrl_id))

/* ɸCAN-ID */
#define CAN_GET_STD_ID		18U

/* ꥹȼ */
#define CAN_GET_MBOX_LIST	8U

/* åХåե(FCNnMmSSMT) */
#define CAN_BUFF_MASK_BIT(index)	((index) << 3U)

/* ӥå */
#define CAN_BIT0	0x0001U
#define CAN_BIT1	0x0002U
#define CAN_BIT2	0x0004U
#define CAN_BIT3	0x0008U
#define CAN_BIT4	0x0010U
#define CAN_BIT5	0x0020U
#define CAN_BIT6	0x0040U
#define CAN_BIT7	0x0080U
#define CAN_BIT8	0x0100U
#define CAN_BIT9	0x0200U
#define CAN_BIT10	0x0400U
#define CAN_BIT11	0x0800U
#define CAN_BIT12	0x1000U
#define CAN_BIT13	0x2000U
#define CAN_BIT14	0x4000U
#define CAN_BIT15	0x8000U

/*
 *  쥸
 */
#define FCNn_BASE(no)	(0xFF480000U + (0x20000U * no))

#define FCNnGMCSPRE(no)	(*(volatile uint8 *) (FCNn_BASE(no) + 0x0008U))
#define FCNnGMCLCTL(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8000U))
#define FCNnCMBRPRS(no)	(*(volatile uint8 *) (FCNn_BASE(no) + 0x0268U))
#define FCNnCMIECTL(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8258U))
#define FCNnCMCLCTL(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8240U))
#define FCNnCMBTCTL(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8270U))
#define FCNnCMLCSTR(no)	(*(volatile uint8 *) (FCNn_BASE(no) + 0x0248U))
#define FCNnCMISCTL(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8260U))
#define FCNnCMRGRX(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8280U))
#define FCNnCMTGTX(no)	(*(volatile uint16 *) (FCNn_BASE(no) + 0x8290U))

#define ICFCN0REC	(*(volatile uint16 *) (0xFFFF60D6U))
#define ICFCN0TRX	(*(volatile uint16 *) (0xFFFF60D8U))
#define ICFCN1REC	(*(volatile uint16 *) (0xFFFF610AU))
#define ICFCN1TRX	(*(volatile uint16 *) (0xFFFF610CU))

/* FCN åХåե쥸Υեå */
#define FCNnMmDTLGB_OFFSET(mb)			(0x01020U + ((mb) * 0x40U))
#define FCNnMmSTRB_OFFSET(mb)			(0x01024U + ((mb) * 0x40U))
#define FCNnMmMID0W_OFFSET(mb)			(0x11028U + ((mb) * 0x40U))
#define FCNnMmCTL_OFFSET(mb)			(0x09038U + ((mb) * 0x40U))
#define FCNnMmDATxB_OFFSET(mb, byte)	(0x01000U + ((byte) * 0x04U) + ((mb) * 0x40U))

/* ե륿ޥ쥸Υեå */
#define FCNnCMMKCTLaW_OFFSET(pattern)	(0x10300U + ((pattern) * 0x10U))

/*
 *  åХåե쥸ɥ쥹
 *    FCNnMmDTLGB  - ǡĹ쥸
 *    FCNnMmSTRB   - ե졼쥸
 *    FCNnMmMID0W  - ID쥸
 *    FCNnMmCTL    - 쥸
 *    FCNnMmDATxB  - ǡХȥ쥸
 */
#define FCNnMmDTLGB(no, mb_no)				(*(volatile uint8  *) (FCNn_BASE(no) + FCNnMmDTLGB_OFFSET(mb_no)))
#define FCNnMmSTRB(no, mb_no)				(*(volatile uint8  *) (FCNn_BASE(no) + FCNnMmSTRB_OFFSET(mb_no)))
#define FCNnMmDATxB(no, mb_no, data_size)	(*(volatile uint8  *) (FCNn_BASE(no) + FCNnMmDATxB_OFFSET(mb_no, data_size)))
#define FCNnMmCTL(no, mb_no)				(*(volatile uint16 *) (FCNn_BASE(no) + FCNnMmCTL_OFFSET(mb_no)))
#define FCNnMmMID0W(no, mb_no)				(*(volatile uint32 *) (FCNn_BASE(no) + FCNnMmMID0W_OFFSET(mb_no)))

/* ե륿ޥ쥸ɥ쥹 */
#define FCNnCMMKCTLaW(no, pattern_no)		(*(volatile uint32 *) (FCNn_BASE(no) + FCNnCMMKCTLaW_OFFSET(pattern_no)))

/*
 *  쥸
 */
/* ߵ */
#define ENABLE_ICFCN0REC()	(ICFCN0REC = ICFCN0REC & ~0x0080U)
#define ENABLE_ICFCN0TRX()	(ICFCN0TRX = ICFCN0TRX & ~0x0080U)
#define ENABLE_ICFCN1REC()	(ICFCN1REC = ICFCN1REC & ~0x0080U)
#define ENABLE_ICFCN1TRX()	(ICFCN1TRX = ICFCN1TRX & ~0x0080U)

/* ߶ػ */
#define DISABLE_ICFCN0REC()	(ICFCN0REC = ICFCN0REC | 0x0080U)
#define DISABLE_ICFCN0TRX()	(ICFCN0TRX = ICFCN0TRX | 0x0080U)
#define DISABLE_ICFCN1REC()	(ICFCN1REC = ICFCN1REC | 0x0080U)
#define DISABLE_ICFCN1TRX()	(ICFCN1TRX = ICFCN1TRX | 0x0080U)

/*
 * [CAN077][CAN284][CAN385][CAN386] åȰ¸
 */
extern const CAN_CTRL_INIB	*p_cur_can_ctrl_inib_table;
extern uint8				can_interrupt_nested_cnt[];

/* ؿץȥ */
LOCAL_INLINE boolean can_target_init_unit_phase1(const Can_ConfigType *p_can_config);
LOCAL_INLINE boolean can_target_init_controller_phase1(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_init_controller_phase2(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_init_controller_phase3(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_rbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hrh_idx);
LOCAL_INLINE boolean can_target_tbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hth_idx);
LOCAL_INLINE boolean can_target_init_unit_phase2(const Can_ConfigType *p_can_config);
LOCAL_INLINE boolean can_target_change_baudrate(uint8 ctrl_id, const Can_ControllerBaudrateConfigType *p_baudrate_table);
LOCAL_INLINE boolean can_target_start_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_stop_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_sleep_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_wakeup_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_disable_controller_interrupts(uint8 ctrl_id);
LOCAL_INLINE boolean can_target_enable_controller_interrupts(uint8 ctrl_id);
LOCAL_INLINE boolean can_target_check_wakeup(uint8 ctrl_id);
LOCAL_INLINE Can_ReturnType can_target_transmit(uint8 ctrl_id, uint8 mb_idx, const Can_PduType *PduInfo);
LOCAL_INLINE boolean can_target_check_and_get_rbox(uint8 ctrl_id, Can_HwHandleType *p_rbox_idx);
LOCAL_INLINE boolean can_target_get_rdata(uint8 ctrl_id, Can_HwHandleType rbox_id, Can_IdType *p_can_id, uint8 *p_can_dlc, uint8 can_sdu[]);
LOCAL_INLINE boolean can_target_check_and_get_tbox(uint8 ctrl_id, Can_HwHandleType *p_tbox_idx);
LOCAL_INLINE Can_StateTransitionType can_target_get_mode(uint8 ctrl_id);
LOCAL_INLINE void can_target_busy_wait(void);

/* [CAN407] Can_Initunit_phase1 */
LOCAL_INLINE boolean
can_target_init_unit_phase1(const Can_ConfigType *p_can_config)
{
	/* ˥åȤ˴ؤ̵ */
	return(TRUE);
}

/* [CAN407] Can_Initcontroller_phase1 */
LOCAL_INLINE boolean
can_target_init_controller_phase1(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	boolean	ret;
	uint16	gmclctl_reg;
	uint16	bit_tx;
	uint16	bit_rx;

	/* FCN³ݡȼ */
	if (ctrl_id == 0U) {
		bit_tx = CAN_BIT4;
		bit_rx = CAN_BIT5;
	}
	else {
		bit_tx = CAN_BIT7;
		bit_rx = CAN_BIT6;
	}

	/* [CAN239] FCNnTXݡȽ */
	sil_wrh_mem((void *) PMC(0U), sil_reh_mem((void *) PMC(0U)) | bit_tx);
	sil_wrh_mem((void *) PFCE(0U), sil_reh_mem((void *) PFCE(0U)) & ~bit_tx);
	sil_wrh_mem((void *) PFC(0U), sil_reh_mem((void *) PFC(0U)) & ~bit_tx);
	sil_wrh_mem((void *) PM(0U), sil_reh_mem((void *) PM(0U)) & ~bit_tx);

	/* [CAN239] FCNnRXݡȽ */
	sil_wrh_mem((void *) PMC(0U), sil_reh_mem((void *) PMC(0U)) | bit_rx);
	sil_wrh_mem((void *) PFCE(0U), sil_reh_mem((void *) PFCE(0U)) & ~bit_rx);
	sil_wrh_mem((void *) PFC(0U), sil_reh_mem((void *) PFC(0U)) & ~bit_rx);
	sil_wrh_mem((void *) PM(0U), sil_reh_mem((void *) PM(0U)) | bit_rx);

	/*
	 *  եȥꥻåȼ¹Գ
	 *  FCNnGMCLCTL(Х쥸) - FCN⥸塼ư˻
	 *  FCNnGMCLCTL.FCNnGMCLSESR(եȥꥻåȳ)ӥåȤ򥻥å
	 *  եȥꥻåȤ򳫻
	 */
	FCNnGMCLCTL(ctrl_id) = CAN_BIT12;

	/* ӥȽ */
	can_target_busy_wait();

	/*
	 *  եȥꥻåȼ¹Խλǧ
	 *  FCNnGMCLCTL.FCNnGMCLSORF(եȥꥻåȼ¹ԥơ)ӥåȤǧ
	 *  եȥꥻåȤ¹ԤƤʤȤǧ
	 */
	gmclctl_reg = FCNnGMCLCTL(ctrl_id);

	if ((gmclctl_reg & CAN_BIT4) == CAN_BIT4) {
		ret = FALSE;
		goto error_exit;
	}

	/*
	 *  åХåեRAM ɤ߽Ф顼å
	 *  FCNnGMCLCTL.FCNnGMCLECCFΥӥåȤǧ
	 *  顼ͭ(եȥꥻåȼ¹˥åȤ)硤Det顼Ȥ
	 */
	if ((gmclctl_reg & CAN_BIT5) == CAN_BIT5) {
		ret = FALSE;
		goto error_exit;
	}

	/*
	 *  FCN⥸塼롦ƥࡦå
	 *  FCNnGMCSPRSC - ʬ
	 */
	FCNnGMCSPRE(ctrl_id) = 0x0000U;

	/*
	 *  ⥸塼ư
	 *  FCNnGMCLCTL.FCNnGMCLSEOM˥ӥåȤ򥻥å(1)
	 *    FCNnGMCLPWOMӥåȤ1˥åȤ
	 *    FCNnGMCLPWOMFCN⥸塼ư⡼(0:ػ/1:)Υӥå
	 *    ⡼桤ޤFCNnGMCLESDEåȤ줿ľΤߥꥢǽ
	 */
	FCNnGMCLCTL(ctrl_id) = CAN_BIT8;

	ret = TRUE;

  error_exit:
	return(ret);
}

/* [CAN407] Can_Initcontroller_phase2 */
LOCAL_INLINE boolean
can_target_init_controller_phase2(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	uint16 pattern_idx;

	/* ߶ػ߽ */
	can_target_disable_controller_interrupts(ctrl_id);

	/* ե륿ޥ쥸(FCNnCMMKCTLaW) */
	for (pattern_idx = 0U; pattern_idx < p_ctrl_inib->tnum_filtermask; pattern_idx++) {
		FCNnCMMKCTLaW(ctrl_id, pattern_idx) = (uint32) ((~((p_ctrl_inib->p_filtermask_table[pattern_idx]) << 18U)) & 0x1FFC0000U);
	}

	return(TRUE);
}

/* [CAN407] Can_Initcontroller_phase3 */
LOCAL_INLINE boolean
can_target_init_controller_phase3(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/*
	 *  顼󥯥ꥢ
	 *  FCNnCMLCSTR.FCNnCMLCSSLC[2:0]ΥӥåȤ0˥ꥢ
	 *    顼󤬥顼̵ꤵ
	 */
	FCNnCMLCSTR(ctrl_id) = 0x00U;

	/* [CAN419] ߥơ(FCNnCMISCTL)쥸 */
	/*
	 *  FCNnCMISCTL.FCNnCMISITSF[6:0]ΥӥåȤ򥻥å(1)
	 *    1:FCNnCMISCTL.FCNnCMISITSF[6:0](FCNߥơ)ӥåȤ0˥ꥢ
	 *    ϢװαΤΤϤʤȤꤹ
	 */
	FCNnCMISCTL(ctrl_id) = (CAN_BIT6 | CAN_BIT5 | CAN_BIT4 | CAN_BIT3 | CAN_BIT2 | CAN_BIT1 | CAN_BIT0);

	/*
	 *  ꥹȥꥢ
	 *  FCNnCMRGRX.FCNnCMRGCLRVӥåȤ򥻥å(1)
	 *    1:FCNnCMRGRVFF(ꥹȥХե)ӥåȤ0˥ꥢ
	 *    ɤ߽ФƤʤåХåեֹϤ٤¸
	 */
	FCNnCMRGRX(ctrl_id) = CAN_BIT0;

	/*
	 *  ꥹȥꥢ
	 *  FCNnCMTGTX.FCNnCMTGCLTVӥåȤ򥻥å(1)
	 *    1:FCNnCMTGTVFF(ꥹȥХե)ӥåȤ0˥ꥢ
	 *    ɤ߽ФƤʤåХåեֹϤ٤¸
	 */
	FCNnCMTGTX(ctrl_id) = CAN_BIT0;

	/* [CAN259] ⥸塼쥸ν */
	/*
	 *  顼󥿥ꥢ
	 *    FCNnCMCLCTL.FCNnCMCLSERCΥӥåȤ򥻥å(1)
	 *    ⡼˥ꥢ
	 *  ͭåե졼ม
	 *    FCNnCMCLCTL.FCNnCMCLCLVLΥӥåȤ򥻥å(1)
	 *      FCNnCMCLVALFӥåȤ0˥ꥢ
	 *      FCNnCMCLVALFǸ0˥ꥢ줿塤ͭʥåϼƤʤ
	 *  ѥ֥⡼̤
	 *    FCNnCMCLCTL.FCNnCMCLCLPS[1:0]ΥӥåȤ򥻥å(1)
	 *      1:FCNnCMCLMDPF[1:0](ѥ֥⡼)ӥåȤ0˥ꥢ
	 *      ѥ֥⡼̤ꤹ(⡼̤бΤ)
	 *  ⡼ɤ
	 *    FCNnCMCLCTL.FCNnCMCLCLOP[2:0]ΥӥåȤ򥻥å(1)
	 *      1:FCNnCMCLMDOF[2:0](ư⡼)ӥåȤ0˥ꥢ
	 *      FCN⥸塼뤬⡼Τư⡼̤ꤹ
	 */
	FCNnCMCLCTL(ctrl_id) = (CAN_BIT15 | CAN_BIT5 | CAN_BIT4 | CAN_BIT3 | CAN_BIT2 | CAN_BIT1 | CAN_BIT0);

	return(TRUE);
}

/* [CAN407] Can_Init᡼ܥå */
LOCAL_INLINE boolean
can_target_rbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hrh_idx)
{
	boolean	ret;
	sint8	mask_list_bit;
	uint16	set_buff_bit;
	uint16	gmclctl_reg;
	uint16	i;
	uint32	can_id_reg;

	/*
	 *  FCNnMmCTL.FCNnMmCLRY(FCNnMmRDYF)ӥåȤ򥻥å(1)
	 *    1:FCNnMmRDYFΥӥåȤ0˥ꥢ
	 */
	FCNnMmCTL(ctrl_id, hrh_idx) = CAN_BIT0;

	/* ӥȽ */
	can_target_busy_wait();

	gmclctl_reg = FCNnMmCTL(ctrl_id, hrh_idx);

	/*
	 *  åХåե񤭹ߵ
	 *  FCNnMmCTL.FCNnMmRDYF(åХåե)ӥåȤ0˥ꥢƤ뤫ǧ
	 *  åХåեؤν񤭹ߤǽȤʤ
	 *  åХåեϽ񤭹ߵĤԤ
	 */
	if ((gmclctl_reg & CAN_BIT0) == CAN_BIT0) {
		ret = FALSE;
		goto error_exit;
	}

	/* ե륿ޥͤؤΥǥå */
	if (p_ctrl_inib->tnum_filtermask == 0U) {
		mask_list_bit = 0x01U;
	}
	else {
		mask_list_bit = GET_RBOX_FILTER_MASK_IDX(ctrl_id, hrh_idx);

		/* ե륿ޥ̵ͭȽ */
		if (mask_list_bit == CAN_NO_MASK_IDX) {
			mask_list_bit = 0x01U;
		}
		else {
			mask_list_bit += 0x02U;
		}
	}

	/* ե륿ޥӥå */
	set_buff_bit = CAN_BUFF_MASK_BIT(mask_list_bit);

	/*
	 *  åХåե
	 *    FCNnMmSTRB.FCNnMmSSOW(Х饤)ӥåȤ򥻥å(1)
	 *    ǡƤåХåե˿˼ǡξ񤭤
	 *    FCNnMmSTRB.FCNnMmSSMT(åХåե)ӥåȤ򥻥å(1)
	 *    åХåեΥפꤹ
	 *    FCNnMmSTRB.FCNnMmSSAM(åХåե)ӥåȤ򥻥å(1)
	 *    åХåեѤ뤿ꤹ
	 */
	FCNnMmSTRB(ctrl_id, hrh_idx) = (CAN_BIT7 | set_buff_bit | CAN_BIT0);

	/* CAN-ID(FCNnMmMID0W쥸) */
	can_id_reg = ((uint32) GET_RBOX_CAN_ID(ctrl_id, hrh_idx)) << CAN_GET_STD_ID;
	FCNnMmMID0W(ctrl_id, hrh_idx) = can_id_reg;

	/* DLC(FCNnMmDTLGB쥸) */
	FCNnMmDTLGB(ctrl_id, hrh_idx) = 0x00U;

	/*
	 * ǡ(FCNnMmDATxB쥸)
	 */
	for (i = 0U; i < CAN_MAX_DLC; i++) {
		FCNnMmDATxB(ctrl_id, hrh_idx, i) = 0x00U;
	}

	/*
	 *  ߵ
	 *  FCNnMmCTL.FCNnMmSEIEΥӥåȤ򥻥å(1)
	 *    1:FCNnMmIENF(åХåե׵)ӥåȤ1˥åȤ
	 *    åλߤ
	 *  åХåե񤭹߶ػ
	 *  FCNnMmCTL.FCNnMmSERYΥӥåȤ򥻥å(1)
	 *    1:FCNnMmRDYFΥӥåȤ1˥åȤ
	 */
	FCNnMmCTL(ctrl_id, hrh_idx) = (CAN_BIT11 | CAN_BIT8);

	ret = TRUE;

  error_exit:
	return(ret);
}

/* [CAN407] Can_Init᡼ܥå */
LOCAL_INLINE boolean
can_target_tbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hth_idx)
{
	boolean	ret;
	uint16	mmctl_reg;
	uint16	i;

	hth_idx += TX_MB_START_IDX(ctrl_id);

	/*
	 *  FCNnMmCTL.FCNnMmCLRY(FCNnMmRDYF)ӥåȤ򥻥å(1)
	 *    1:FCNnMmRDYFΥӥåȤ0˥ꥢ
	 */
	FCNnMmCTL(ctrl_id, hth_idx) = CAN_BIT0;

	/* ӥȽ */
	can_target_busy_wait();

	mmctl_reg = FCNnMmCTL(ctrl_id, hth_idx);

	/* FCNnMmCTL.FCNnMmRDYFӥåȤꥢƤ뤫ǧ */
	if ((mmctl_reg & CAN_BIT0) == CAN_BIT0) {
		ret = FALSE;
		goto error_exit;
	}

	/* [CAN236][CAN237] åХåե */
	/*
	 *  FCNnMmSTRB.FCNnMmSSAMӥåȤ򥻥åȤ
	 *  åХåեѤԤ
	 */
	FCNnMmSTRB(ctrl_id, hth_idx) = CAN_BIT0;

	/* CAN-ID(FCNnMmMID0W쥸) */
	FCNnMmMID0W(ctrl_id, hth_idx) = 0x00000000U;

	/* DLC(FCNnMmDTLGB쥸) */
	FCNnMmDTLGB(ctrl_id, hth_idx) = 0x00U;

	/* ǡ(FCNnMmDATxB쥸) */
	for (i = 0U; i < CAN_MAX_DLC; i++) {
		FCNnMmDATxB(ctrl_id, hth_idx, i) = 0x00U;
	}

	/*
	 *  λߵ(FCNnMmCTL.FCNnMmSEIEΥӥåȤ򥻥å)
	 *  åХåե񤭹߶ػ(FCNnMmCTL.FCNnMmSERYΥӥåȤ򥻥å)Ԥ
	 */
	FCNnMmCTL(ctrl_id, hth_idx) = (CAN_BIT11 | CAN_BIT8);

	ret = TRUE;

  error_exit:
	return(ret);
}

/* [CAN407] Can_Initunit_phase2 */
LOCAL_INLINE boolean
can_target_init_unit_phase2(const Can_ConfigType *p_can_config)
{
	/* ˥åȤ˴ؤ̵ */
	return(TRUE);
}

/* Can_ChangeBaudrate */
LOCAL_INLINE boolean
can_target_change_baudrate(uint8 ctrl_id, const Can_ControllerBaudrateConfigType *p_baudrate_table)
{
	/* [CAN255] CANץȥ롦쥤δܥƥࡦå */
	if (p_baudrate_table->CanControllerBaudRate == 250U) {
		FCNnCMBRPRS(ctrl_id) = FCN_BRP_250;
	}
	else {
		FCNnCMBRPRS(ctrl_id) = FCN_BRP_500;
	}

	/* [CAN255] DBT20ץݥ75.0% */
	FCNnCMBTCTL(ctrl_id) = FCN_BTCTL_20_75;

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_START */
LOCAL_INLINE boolean
can_target_start_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/*[CAN261] ̾ư⡼ɤ */
	/*
	 *  FCNnCMCLCTL.FCNnCMCLSEOP[0]ΥӥåȤ򥻥å(1)
	 *    1:FCNnCMCLMDOF[0]ΥӥåȤ1˥åȤ
	 *  FCNnCMCLCTL.FCNnCMCLCLOP[2:1]ΥӥåȤ򥻥å(1)
	 *    1:FCNnCMCLMDOF[2:1]ΥӥåȤ0˥ꥢ
	 *    FCNnCMCLMDOF[2:0](ư⡼ɥӥå) - 001:̾ư⡼
	 */
	FCNnCMCLCTL(ctrl_id) = (CAN_BIT8 | CAN_BIT2 | CAN_BIT1);

	/* [CAN204][CAN425] ߶ػߥͥȥȽ */
	if (can_interrupt_nested_cnt[ctrl_id] == 0U) {
		/* [CAN196] ߵĽ */
		can_target_enable_controller_interrupts(ctrl_id);
	}

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_STOP */
LOCAL_INLINE boolean
can_target_stop_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* [CAN204][CAN426] ߶ػߥͥȥȽ */
	if (can_interrupt_nested_cnt[ctrl_id] == 0U) {
		/* [CAN197] ߶ػ߽ */
		can_target_disable_controller_interrupts(ctrl_id);
	}

	/* [CAN263] ⡼ɤ */
	/*
	 *  FCNnCMCLCTL.FCNnCMCLCLOP[2:0]ΥӥåȤ򥻥å(1)
	 *    1:FCNnCMCLMDOF[2:0](ư⡼)ӥåȤ0˥ꥢ
	 *    000:⡼̤(⡼)
	 */
	FCNnCMCLCTL(ctrl_id) = (CAN_BIT2 | CAN_BIT1 | CAN_BIT0);

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_SLEEP */
LOCAL_INLINE boolean
can_target_sleep_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* CAN_T_SLEEP̤ݡ */
	return(FALSE);
}

/* Can_SetControllerModeCAN_T_WAKEUP */
LOCAL_INLINE boolean
can_target_wakeup_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* CAN_T_WAKEUP̤ݡ */
	return(FALSE);
}

/* Can_DisableControllerInterrupts */
LOCAL_INLINE boolean
can_target_disable_controller_interrupts(uint8 ctrl_id)
{
	/*
	 *  ߶ػ
	 *  FCNnCMIEINTF[0](λб)ΥӥåȤ0˥ꥢ
	 *    λߤػߤ
	 *  FCNnCMIEINTF[1](λб)ΥӥåȤ0˥ꥢ
	 *    λߤػߤ
	 */
	FCNnCMIECTL(ctrl_id) = (CAN_BIT0 | CAN_BIT1);

	if (ctrl_id == 0U) {
		DISABLE_ICFCN0REC();
		DISABLE_ICFCN0TRX();
	}
	else {
		DISABLE_ICFCN1REC();
		DISABLE_ICFCN1TRX();
	}

	return(TRUE);
}

/* Can_EnableControllerInterrupts */
LOCAL_INLINE boolean
can_target_enable_controller_interrupts(uint8 ctrl_id)
{
	/*
	 *  ߵ
	 *  FCNnCMIEINTF[0](λб)ΥӥåȤ1˥åȤ
	 *    λߤĤ
	 *  FCNnCMIEINTF[1](λб)ΥӥåȤ1˥åȤ
	 *    λߤĤ
	 */
	FCNnCMIECTL(ctrl_id) = (CAN_BIT8 | CAN_BIT9);

	if (ctrl_id == 0U) {
		ENABLE_ICFCN0REC();
		ENABLE_ICFCN0TRX();
	}
	else {
		ENABLE_ICFCN1REC();
		ENABLE_ICFCN1TRX();
	}

	return(TRUE);
}

/* Can_CheckWakeup */
LOCAL_INLINE boolean
can_target_check_wakeup(uint8 ctrl_id)
{
	/* åפ̤ݡ */
	return(FALSE);
}

/* Can_Writeǡڤ׵ */
LOCAL_INLINE Can_ReturnType
can_target_transmit(uint8 ctrl_id, Can_HwHandleType mb_idx, const Can_PduType *PduInfo)
{
	Can_ReturnType	ret;
	uint8			i;
	uint16			mmctl_reg;

	/* ᡼ܥåɥ쥹Ǽΰ */
	mb_idx += TX_MB_START_IDX(ctrl_id);

	/*
	 *  check TRQF
	 *  FCNnMmCTL.FCNnMmTRQF(åХåե׵)ӥåȳǧ
	 *    åХåե˥å׵(αޤ)ʤȤǧ
	 */
	mmctl_reg = FCNnMmCTL(ctrl_id, mb_idx);
	if ((mmctl_reg & CAN_BIT1) == CAN_BIT1) {
		ret = CAN_BUSY;
		goto error_exit;
	}

	/* åХåե񤭹ߵĤ */
	FCNnMmCTL(ctrl_id, mb_idx) = CAN_BIT0;

	/* ӥȽ */
	can_target_busy_wait();

	mmctl_reg = FCNnMmCTL(ctrl_id, mb_idx);

	/*  FCNnMmCTL.FCNnMmRDYFӥåȤꥢƤ뤫ǧ */
	if ((mmctl_reg & CAN_BIT0) == CAN_BIT0) {
		ret = CAN_NOT_OK;
		goto error_exit;
	}

	/*
	 *  CAN-IDγǼ
	 *  FCNnMmMID0WCANID(Can_PduTypeid)򥻥åȤ
	 */
	FCNnMmMID0W(ctrl_id, mb_idx) = PduInfo->id << CAN_GET_STD_ID;

	/*
	 *  ǡĹγǼ
	 *  FCNnMmDTLGBDLC(Can_PduTypelength)򥻥åȤ
	 */
	FCNnMmDTLGB(ctrl_id, mb_idx) = PduInfo->length;

	/* [CAN059][CAN427] ǡγǼ */
	/* FCNnMmDATxBDLCʬΥǡ(Can_PduTypesdu)򥻥åȤ */
	for (i = 0U; i < PduInfo->length; i++) {
		FCNnMmDATxB(ctrl_id, mb_idx, i) = PduInfo->sdu[i];
	}

	/*
	 *  åХåե񤭹߶ػߤ
	 *  FCNnMmCTL.FCNnMmSERYΥӥåȤ򥻥å(1)
	 *  FCNnMmRDYFΥӥåȤ1˥åȤ
	 */
	FCNnMmCTL(ctrl_id, mb_idx) = CAN_BIT8;

	/*
	 *  ׵
	 *  FCNnMmCTL.FCNnMmSETRΥӥåȤ򥻥å(1)
	 *  FCNnMmTRQFӥåȤ1˥åȤ
	 */
	FCNnMmCTL(ctrl_id, mb_idx) = CAN_BIT9;

	ret = CAN_OK;

  error_exit:
	return(ret);
}

/* Can_IsrRx᡼ܥå */
LOCAL_INLINE boolean
can_target_check_and_get_rbox(uint8 ctrl_id, Can_HwHandleType *p_rbox_idx)
{
	boolean	ret;
	uint16	cmrgrx;

	/* ꥹȼ */
	cmrgrx = FCNnCMRGRX(ctrl_id);
	*p_rbox_idx = (Can_HwHandleType) (cmrgrx >> CAN_GET_MBOX_LIST);

	/* ꥹȥСեå */
	if ((cmrgrx & CAN_BIT0) != 0U) {
		/* ꥹȥСեӥåȤΥꥢ */
		FCNnCMRGRX(ctrl_id) = CAN_BIT0;
	}

	/*
	 *  åΥ꡼Ƚ
	 *  FCNnCMRGRX.FCNnCMRGSSPMΥӥåȤ1åȤƤ뤫ǧ
	 *  0˥ꥢƤС̤꡼ɤΥ᡼ܥåʤȤʤ
	 */
	if ((cmrgrx & CAN_BIT1) != 0U) {
		/* ̤꡼ɤΥ᡼ܥå̵ */
		ret = FALSE;
	}
	else {
		ret = TRUE;
	}

	return(ret);
}

/* Can_IsrRxIDΥǡ */
LOCAL_INLINE boolean
can_target_get_rdata(uint8 ctrl_id, Can_HwHandleType rbox_id, Can_IdType *p_can_id, uint8 *p_can_dlc, uint8 can_sdu[])
{
	boolean	ret;
	uint8	i;
	uint8	local_dlc;
	uint16	mmctl_reg;

	/*
	 *  (DTNF)ꥢ
	 *  FCNnMmCTL.FCNnMmCLDNӥåȤ򥻥å(1)
	 *    1:FCNnMmCTL.FCNnMmDTNF0˥ꥢ
	 *    ᡼ܥåǡ
	 */
	FCNnMmCTL(ctrl_id, rbox_id) = CAN_BIT2;

	/* FCNnMmMID0WCAN-ID */
	*p_can_id = FCNnMmMID0W(ctrl_id, rbox_id) >> CAN_GET_STD_ID;

	/* FCNnMmDTLGBDLCμ */
	local_dlc = FCNnMmDTLGB(ctrl_id, rbox_id);
	*p_can_dlc = local_dlc;

	/* [CAN012][CAN060][CAN299][CAN300] FCNnMmDATxBǡ */
	for (i = 0U; i < local_dlc; i++) {
		can_sdu[i] = FCNnMmDATxB(ctrl_id, rbox_id, i);
	}

	/*
	 *  ǡǧ
	 *  FCNnMmCTL.FCNnMmMUCFӥåȤ0˥ꥢƤ뤫ǧ
	 *  :FCN⥸塼뤬᡼ܥå򹹿Ƥʤ
	 *  FCNnMmCTL.FCNnMmDTNFӥåȤǡ̵Ȥǧ
	 */
	mmctl_reg = FCNnMmCTL(ctrl_id, rbox_id);
	if ((mmctl_reg & (CAN_BIT13 | CAN_BIT2)) != 0U) {
		ret = FALSE;
	}
	else {
		ret = TRUE;
	}

	return(ret);
}

/* Can_IsrTx᡼ܥåå */
LOCAL_INLINE boolean
can_target_check_and_get_tbox(uint8 ctrl_id, Can_HwHandleType *p_tbox_idx)
{
	boolean				ret;
	Can_HwHandleType	mb_idx;
	uint16				cmtgtx;

	/* ꥹȼ */
	cmtgtx = FCNnCMTGTX(ctrl_id);
	mb_idx = (Can_HwHandleType) (cmtgtx >> CAN_GET_MBOX_LIST);
	*p_tbox_idx = mb_idx - TX_MB_START_IDX(ctrl_id);

	/* ꥹȥСեå */
	if ((cmtgtx & CAN_BIT0) != 0U) {
		/* ꥹȥСեӥåȤΥꥢ */
		FCNnCMTGTX(ctrl_id) = CAN_BIT0;
	}

	/*
	 * åΥ꡼Ƚ
	 * FCNnCMRGRX.FCNnCMRGSSPMΥӥåȤǧ
	 */
	if ((cmtgtx & CAN_BIT1) != 0U) {
		/* ̤꡼ɤΥ᡼ܥå̵ */
		ret = FALSE;
	}
	else {
		ret = TRUE;
	}

	return(ret);
}

LOCAL_INLINE Can_StateTransitionType
can_target_get_mode(uint8 ctrl_id)
{
	Can_StateTransitionType	ret;
	uint16					cmclctl_reg;

	/* ư⡼ɼ */
	cmclctl_reg = FCNnCMCLCTL(ctrl_id);

	/* [CAN384][CAN409][CAN410] ư⡼Ƚ */
	if ((cmclctl_reg & (CAN_BIT2 | CAN_BIT1 | CAN_BIT0)) != CAN_BIT0) {
		ret = CAN_T_STOP;
	}
	else {
		ret = CAN_T_START;
	}

	return(ret);
}

LOCAL_INLINE void
can_target_busy_wait(void)
{
	volatile uint32 i;

	/* ӥȽ */
	for (i = 0U; i < 100000U; i++) {
	}
}

/*
 *  ¸Ǥ̤ݡȵǽ
 *    <CAN048><CAN294><CAN361><CAN461> åפ̤ݡȤΤᡤбʤ
 *    <CAN257><CAN265><CAN267><CAN411><CAN412> ϡɥSLEEP⡼ɤ̤ݡȤΤᡤбʤ
 *    <CAN282><CAN283> 󥻥̤ݡȤΤᡤбʤ
 *    <CAN258><CAN290><CAN404><CAN405>ŪSLEEP⡼ɤ̤ݡȤΤᡤбʤ
 *    <CAN238><CAN242><CAN391><CAN244> hsbv850e2fg4Ǥ̤ݡȤΤᡤбʤ
 *    <CAN062><CAN256><CAN260><CAN422><CAN453> ܡ졼ȤϸΤᡤбʤ
 *    <CAN272><CAN273><CAN274> Хս̤ݡȤΤᡤбʤ
 *    <CAN420> ׵ΥꥢϥϡɥԤᡤбʤ
 */

#endif /* TOPPERS_CAN_PRC_H */
