#!ruby -Ke
#
#  TOPPRES/A-CAN
#      Automotive CAN
#
#  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2013-2014 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: get_spec_id.rb 599 2014-10-17 01:27:58Z shigihara $
#

#
#  λͥФ
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# оݥե
aTargetFiles = []
aTargetFiles.push("#{TOOL_ROOT}/../../Can.c")
aTargetFiles.push("#{TOOL_ROOT}/../../Can.h")
aTargetFiles.push("#{TOOL_ROOT}/../../Can_GeneralTypes.h")
aTargetFiles.push("#{TOOL_ROOT}/../../can.tf")

# NCANͽ
aNCANSpecFiles = []
aNCANSpecFiles.push("#{TOOL_ROOT}/../../doc/can_spec.txt")

# оݥɽ
sTagRegNcan = "NCAN[0-9][0-9][0-9]"
sTagRegCanA = "CANa[0-9][0-9][0-9]"
sTagRegCan = "CANa?[0-9][0-9][0-9][_Conf]*"
sTagRegAll = "N?#{sTagRegCan}"

#
# NCANCANaͼ
#
aSpecData = []
aNCANSpecFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aSpecData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hNcanSpecInfo = {}

aSpecData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if ((aLine[0] !~ /\[#{sTagRegNcan}\]/) && (aLine[0] !~ /\[#{sTagRegCanA}\]/))
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/\[#{sTagRegNcan}\]/))
  aTags.concat(aLine[0].scan(/\[#{sTagRegCanA}\]/))

  aTags.each{|sTag|
    if (!hNcanSpecInfo.has_key?(sTag))
      hNcanSpecInfo[sTag] = []
    end
    hNcanSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hNcanSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hNcanSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/nces_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
aNcanSpec = []
aCanASpec = []
aTagID.each{|sTag|
  # NCAN
  if (sTag =~ /\[#{sTagRegNcan}\]/)
    aNcanSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # CANa
  elsif (sTag =~ /\[#{sTagRegCanA}\]/)
    aCanASpec.push(sTag.gsub(/\[(#{sTagRegCanA})\]/, "\\1"))
  else
    abort("Error!!")
  end
}



#
# ɼ
#
aCodeData = []
aTargetFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aCodeData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hSpecInfo = {}

aCodeData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if (aLine[0] !~ /[\[<\(]#{sTagRegAll}[\]>\)]/)
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/[\[<\(]#{sTagRegAll}[\]>\)]/))

  aTags.each{|sTag|
    if (!hSpecInfo.has_key?(sTag))
      hSpecInfo[sTag] = []
    end
    hSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/impl_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
nAutosarCnt = 0
aTargetSpec = []
aNonTargetSpec = []
aImplCanASpec = []
aImplNcanSpec = []
aDependCanSpec = []
aTagID.each{|sTag|
  # CANa
  if (sTag =~ /\[#{sTagRegCanA}\]/)
    aImplCanASpec.push(sTag.gsub(/\[(#{sTagRegCanA})\]/, "\\1"))
  # NCAN
  elsif (sTag =~ /\[#{sTagRegNcan}\]/)
    aImplNcanSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # оݻ
  elsif (sTag =~ /\[#{sTagRegCan}\]/)
    aTargetSpec.push(sTag.gsub(/\[(#{sTagRegCan})\]/, "\\1"))
    nAutosarCnt += 1
  # оݻ
  elsif (sTag =~ /<#{sTagRegCan}>/)
    aNonTargetSpec.push(sTag.gsub(/<(#{sTagRegCan})>/, "\\1"))
    nAutosarCnt += 1
  # ¸
  elsif (sTag =~ /\(#{sTagRegCan}\)/)
    aDependCanSpec.push(sTag.gsub(/\((#{sTagRegCan})\)/, "\\1"))
    nAutosarCnt += 1
  else
    abort("Error!!")
  end
}

# ݡо/оݤηɽ
puts("=" * 35)
puts("AUTOSAR tags         : #{nAutosarCnt}")
puts("-" * 35)
fRatio = aTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For support tags     : #{aTargetSpec.size() + aDependCanSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
fRatio = aNonTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For non-support tags : #{aNonTargetSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
puts("=" * 35)

# ʣɽ
aTargetSpec.each{|sTarget|
  if (aNonTargetSpec.include?(sTarget))
    puts("#{sTarget} is conflicted !!")
    pp hSpecInfo["[#{sTarget}]"]
    pp hSpecInfo["<#{sTarget}>"]
  end
  if (aDependCanSpec.include?(sTarget))
    puts("#{sTarget} is conflicted !!")
    pp hSpecInfo["[#{sTarget}]"]
    pp hSpecInfo["(#{sTarget})"]
  end
}

# ȼηɽ
puts("=" * 35)
puts("NCAN tags       : #{aNcanSpec.size()}")
puts("Implemented tags: #{aImplNcanSpec.size()}")
fCoverage = aImplNcanSpec.size().to_f() / aNcanSpec.size().to_f() * 100
puts("NCAN Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("-" * 35)
puts("CANa tags       : #{aCanASpec.size()}")
puts("Implemented tags: #{aImplCanASpec.size()}")
fCoverage = aImplCanASpec.size().to_f() / aCanASpec.size().to_f() * 100
puts("CANa Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("=" * 35)

# Ƥʤɽ
aNcanSpec.each{|sTag|
  if (!aImplNcanSpec.include?(sTag))
    puts(sTag)
  end
}
aCanASpec.each{|sTag|
  if (!aImplCanASpec.include?(sTag))
    puts(sTag)
  end
}

