/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2014 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: os.c 599 2014-10-17 01:27:58Z shigihara $
 */

#include "Os.h"
#include "Can.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "sysmod/banner.h"
#include "target_serial.h"
#include "prc_sil.h"

#define PSW9		0x02
#define PSW8		0x01
#define DSW1		0x01
#define DSW2		0x02
#define DSW3		0x04
#define DSW4		0x08
#define DSW_OFF		0x00

#define LED1		0x01
#define LED2		0x02
#define LED3		0x04
#define LED4		0x08
#define LED_OFF		0x00

void switch_push_init(void);
uint8 switch_push_sense(void);
void switch_dip_init(void);
uint8 switch_dip_sense(void);
void led_init(void);
void led_out(uint8 led_data);

TASK(MainTask){
	volatile uint32 i;
	uint8			Hth;
	uint32			cur_key;
	uint8			data[8] = {
		0x00U, 0x01U, 0x02U, 0x03U,
		0x04U, 0x05U, 0x06U, 0x07U
	};
	static uint32	pre_key = 0;
	Can_PduType		send_data;
	uint8			ch_no;
	uint8			dsw_state;
	uint8			pre_dsw_state;

	Can_Init(NULL_PTR);

	syslog(LOG_NOTICE, "");
	syslog(LOG_NOTICE, "== Can_Init ==");
	syslog(LOG_NOTICE, "");

	dsw_state = switch_dip_sense();

	if ((dsw_state & DSW1) != DSW1) {
		pre_dsw_state = DSW1;
	}
	if ((dsw_state & DSW1) == DSW1) {
		pre_dsw_state = DSW_OFF;
	}

	while (1) {
		cur_key = switch_push_sense();

		send_data.length = 8U;
		send_data.sdu = data;

		/* DSWξּ */
		dsw_state = switch_dip_sense();

		/* DSWѲȽ */
		if (dsw_state != pre_dsw_state) {
			/* DSW1Ƚ */
			if (((dsw_state & DSW1) != DSW1) && ((pre_dsw_state & DSW1) == DSW1)) {
				/* Controller_0 */
				ch_no = 0;
				Can_SetControllerMode(ch_no, CAN_T_START);
				led_out(LED_OFF);
			}
			if (((dsw_state & DSW1) == DSW1) && ((pre_dsw_state & DSW1) != DSW1)) {
				/* Controller_1 */
				ch_no = 1;
				Can_SetControllerMode(ch_no, CAN_T_START);
				led_out(LED1);
			}
		}
		pre_dsw_state = dsw_state;

		/* ܥ󲡲֤ܤΤ߽Ԥ */
		if (((pre_key & PSW9) == 0) && ((cur_key & PSW9) != 0)) {
			if (ch_no == 0) {
				/* Controller_0 */
				send_data.swPduHandle = 3U;
				send_data.id = 0x01U;
				Hth = 3U;
			}
			else {
				/* Controller_1 */
				send_data.swPduHandle = 8U;
				send_data.id = 0x03U;
				Hth = 8U;
			}

			syslog(LOG_NOTICE, "[PSW9] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}
		else if (((pre_key & PSW8) == 0) && ((cur_key & PSW8) != 0)) {
			if (ch_no == 0) {
				/* Controller_0 */
				send_data.swPduHandle = 4U;
				send_data.id = 0x02U;
				Hth = 4U;
			}
			else {
				/* Controller_1 */
				send_data.swPduHandle = 9U;
				send_data.id = 0x04U;
				Hth = 9U;
			}

			syslog(LOG_NOTICE, "[PSW8] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}

		pre_key = cur_key;

		/*  */
		for (i = 0U; i < 100000U; i++) {
		}
	}

	ShutdownOS(E_OK);
}

boolean
CanCalloutFunction(uint8 Hrh, Can_IdType CanId, uint8 CanDlc, const uint8 *CanSduPtr)
{
	uint8 i;

	syslog(LOG_NOTICE, "CanCalloutFunction:Hrh = 0x%x, CanId = 0x%x, CanDlc = 0x%x", Hrh, CanId, CanDlc);

	for (i = 0U; i < CanDlc; i++) {
		syslog(LOG_NOTICE, "CanCalloutFunction:CanSduPtr[%d] = 0x%x", i, CanSduPtr[i]);
	}

	return(TRUE);
}

ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	syslog(LOG_NOTICE, "## ProtectionHook is called !! (%d)", FatalError);

	return(PRO_SHUTDOWN);
}

void
StartupHook(void)
{
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();

	switch_push_init();
	switch_dip_init();
	led_init();
}

sint32
main(void)
{
	StartOS(MainApp);
	while (1) ;
	return(0);
}

/*
 * PUSHå³ݡ
 *
 * ĥI/OܡɤSW9-8ϥС𤷤³Ƥ롥
 *  INT_SW1/SW9 : P4_7
 *  INT_SW2/SW8 : P4_4
 */

/*
 * PUSHå³ݡȽ
 */
void
switch_push_init(void)
{
	uint16 wk;

	/* SW9(P4_7)*/
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(4));
	wk |= 0x80;
	sil_wrh_mem((void *) PMC(4), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(4));
	wk &= ~0x80;
	sil_wrh_mem((void *) PFCE(4), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(4));
	wk &= ~0x80;
	sil_wrh_mem((void *) PFC(4), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(4));
	wk |= 0x80;
	sil_wrh_mem((void *) PM(4), wk);


	/* SW8(P4_4)*/
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(4));
	wk |= 0x10;
	sil_wrh_mem((void *) PMC(4), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(4));
	wk &= ~0x10;
	sil_wrh_mem((void *) PFCE(4), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(4));
	wk &= ~0x10;
	sil_wrh_mem((void *) PFC(4), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(4));
	wk |= 0x10;
	sil_wrh_mem((void *) PM(4), wk);
}


/*
 * PUSHå֤ɤ߹
 */
uint8
switch_push_sense(void)
{
	uint16	wk;
	uint16	mask;

	wk = sil_reh_mem((void *) PPR(4));
	mask = 0;
	if (wk & 0x80) {
		mask |= PSW9;
	}
	if (wk & 0x10) {
		mask |= PSW8;
	}

	return(mask);
}


/*
 * DIPå³ݡ
 *
 * ĥI/OܡɤSW1-4ϥץޥ֥ϥݡ
 * ˥С𤷤³Ƥ롥
 *  DSW1 : P3_6
 *  DSW2 : P3_7
 *  DSW3 : P0_13
 *  DSW4 : P0_14
 */

/*
 * DIPå³ݡȽ
 */
void
switch_dip_init(void)
{
	uint16 wk;

	/* SW1(P3_6)/SW2(P3_7) */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(3));
	wk &= ~(0x80 | 0x40);
	sil_wrh_mem((void *) PMC(3), wk);

	/* PIBC  */
	wk = sil_reh_mem((void *) PIBC(3));
	wk |= (0x80 | 0x40);
	sil_wrh_mem((void *) PIBC(3), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(3));
	wk |= (0x80 | 0x40);
	sil_wrh_mem((void *) PM(3), wk);


	/* SW3(P0_13)/SW4(P0_14) */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(0));
	wk &= ~(0x2000 | 0x4000);
	sil_wrh_mem((void *) PMC(0), wk);

	/* PIBC  */
	wk = sil_reh_mem((void *) PIBC(0));
	wk |= (0x2000 | 0x4000);
	sil_wrh_mem((void *) PIBC(0), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(0));
	wk |= (0x2000 | 0x4000);
	sil_wrh_mem((void *) PM(0), wk);
}

/*
 * DIPå֤ɤ߹
 */
uint8
switch_dip_sense(void)
{
	uint16	wk;
	uint16	mask;

	wk = sil_reh_mem((void *) PPR(3));

	mask = 0;
	if (wk & 0x40) {
		mask |= DSW1;
	}
	if (wk & 0x80) {
		mask |= DSW2;
	}

	wk = sil_reh_mem((void *) PPR(0));
	if (wk & 0x2000) {
		mask |= DSW3;
	}
	if (wk & 0x4000) {
		mask |= DSW4;
	}

	return(mask);
}

/*
 * LED³ݡ
 *
 * ĥI/OܡɤLED1-3ϥץޥ֥ϥݡ4
 * Τ褦³Ƥ롥
 *  D1 : P4_1
 *  D2 : P4_2
 *  D3 : P4_4
 *  D4 : P4_8
 */

/*
 *  LED³ݡȽ
 */
void
led_init(void)
{
	uint16 wk;

	/* LED ν */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(4));
	wk &= ~0x0f;
	sil_wrh_mem((void *) PMC(4), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(4));
	wk &= ~0x0f;
	sil_wrh_mem((void *) PFCE(4), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(4));
	wk &= ~0x0f;
	sil_wrh_mem((void *) PFC(4), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(4));
	wk &= ~0x0f;
	sil_wrh_mem((void *) PM(4), wk);

	/*  */
	wk = sil_reh_mem((void *) P(4));
	wk &= ~0x0f;
	sil_wrh_mem((void *) P(4), wk);
}


/*
 *  LED³ݡȽ񤭹
 */
void
led_out(uint8 led_data)
{
	uint16 wk;

	led_data &= 0x0f;
	wk = sil_reh_mem((void *) P(4));
	wk &= ~0x0f;
	wk |= led_data;
	sil_wrh_mem((void *) P(4), wk);
}
